; 1-Oct-2024 by KPK

!addr band_no = $fb

* = $801
!pet 11,8,0,0,158,"2061",0,0,0

setup_isr:
  sei        ; disable interrupt
  lda #<isr  ; set interrupt routine to c01f
  sta $0314  ; set low byte
  lda #>isr  ; high byte
  sta $0315  ; set
  lda $d011  ; and for the high bit of the raster position
  and #$7f   ; clear the high bit
  sta $d011  ; and set the cleared high bit
  lda #$f1   ; enable the raster interrupt
  sta $d01a  ; in the appropriate register
  cli        ; allow interrupt
  rts        ; return from subroutine

; --------------------------------------------------------------------

isr:
  lda $d019   ; load vic interrupt register
  sta $d019   ; and clear it
  bmi +       ; if highest bit is set, go to our routine
  lda $dc0d   ; else disable cia interrupt
  cli         ; enable interrupt
  jmp $ea31   ; continue to normal system isr vector

+ ldx band_no ; get the color band number
  lda raster_values,x ; get the raster number for the color band
  cmp $d012   ; compare it to the vic-ii raster number
  bcc +       ; skip if it's less
  lda raster_colors,x ; otherwise get the associated color value
  sta $d020   ; set the border color
  sta $d021   ; set the background color
+ dec band_no ; select the next band
  bpl +       ; if the beginning has been reached...
  lda #$06    ; ...point to the end
  sta band_no
+ lda raster_values,x ; get the next raster number
  sta $d012   ; tell vic-ii chip to generate an interrupt when reached
  jmp $ea81   ; continue to system isr vector

; --------------------------------------------------------------------

raster_colors: !byte $00,$06,$05,$07,$08,$02
raster_values: !byte $b2,$aa,$a2,$9a,$92,$8a,$82